var AnkangBase = cc.Sprite.extend({
    listener:null,
    enable_:null,
    touchable:null,
    ctor:function(path,index){
        this._super(path);
        this.idx = index;
        this.enable_ = true;
        this.touchable = true;
        this.sendable = true;
        this.addListener();
        this.recvevents();
    },
    setEnable_:function(enable_){
        this.enable_ = enable_;
        cc.log("设置base可见");
        this.setVisible(this.enable_);
    },
    recvevents:function(){
        var self = this;
        recvCustomEvent("tell_ankang_close_lamp",function(event){
            var index = parseInt(event.getUserData());
            if(index == self.idx){
                self.setEnable_(true);
            }
        });
    },
    addListener:function(){
        var self = this;
        this.sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode) && self.enable_ && self.touchable) {
                    cc.log("ankang is clicked "+self.idx);

                    self.setEnable_(false);
                    ddStopAllAudios();
                    var idx = self.idx + 1;
                    ddPlayEffect("effect","res/ankang/audio/effect/"+idx+".mp3",false);
                    sendCustomEventAddUserData("tell_ankang_show_lamp",self.idx);
                }
            }
        });
        cc.eventManager.addListener(this.sprite_listener,this);
    }
});

var AnkangClick = cc.Sprite.extend({
    listener:null,
    deltatime:null,
    enable_:null,
    firstSet:null,
    recvable:null,
    ctor:function(path,isFlipped,index){
        this._super(path);
        this.enable_ = true;
        this.deltatime = 0;
        this.firstSet = true;
        this.recvable = true;
        this.ankangindex = index;
        this.isFlipped = isFlipped;
        this.addLamp();
        this.addListener();
        this.recvevents();
    },
    recvevents:function(){
        var self = this;
        recvCustomEvent("tell_ankang_show_lamp",function(event){
           var index = parseInt(event.getUserData());
            if(index == self.ankangindex){
                if(self.recvable){
                    self.recvable = false;
                    self.setVisible(true);
                    self.changeLamp();
                    self.stopAllActions();
                    self.runAction(cc.sequence(cc.delayTime(0.15),cc.spawn(newAnimationCreate(9,"ankang-click",0.15,1,true),cc.sequence(cc.delayTime(0.6),cc.callFunc(function(){
                        self.setEnable_(false);
                        self.recvable = true;
                        sendCustomEventAddUserData("tell_ankang_close_lamp",self.ankangindex)
                    })))));
                }
            }
        });
    },
    addLamp:function(){
        this.ankanglamp = new cc.Sprite("#lamp-blue1.png");
        if(this.isFlipped) {
            this.ankanglamp.setFlippedX(true);
            this.ankanglamp.setPosition(235-200, 98);
        }else{
            this.ankanglamp.setPosition(235, 98);
        }
        this.addChild(this.ankanglamp);

    },
    setEnable_:function(enable){
        if(enable && this.firstSet){
            this.firstSet = false;
            this.scheduleUpdate();
        }
        this.enable_ = enable;
        cc.log("设置click可见");
        this.setVisible(this.enable_);
    },
    changeLamp:function(){
        //newAnimationCreate(number,prefix,delayPerUnit,times,resumeOriginFrame)
        var self = this;
        this.ankanglamp.stopAllActions();
        this.ankanglamp.runAction(cc.sequence(newAnimationCreate(9,Config_Play.ankang.lamps.colors[self.ankangindex],0.05,1,false)));
    },
    addListener:function(){
        var self = this;
        this.sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode) && self.enable_) {
                        ddStopAllEffects();
                        var idx = self.ankangindex + 1;
                        ddPlayEffect("effect","res/ankang/audio/effect/"+idx+".mp3",false);
                        cc.log("ankangclick is clicked : "+"res/ankang/audio/effect/"+self.ankangindex+".mp3");
                        self.changeLamp();

                }
            }
        });
        cc.eventManager.addListener(this.sprite_listener,this);
    },
    update:function(dt){
        if(this.isVisible()){
            this.deltatime += dt;
            if(dt > 5){
                this.setEnable_(false);
            }
        }else{
            this.deltatime = 0;
        }
    }
});

var AnkangSprite = AnkangBase.extend({
    ctor:function(path,index){
        this._super(path,index);
        this.createAnimations();
    },
    createAnimations:function(){
        this.ankangeat = cc.sequence(newAnimationCreate(12,"ankang-eat",0.04,1,false));
        this.ankanglaugh = cc.sequence(newAnimationCreate(7,"ankang-laugh",0.05,1,false));
        this.ankangnormal = cc.sequence(newAnimationCreate(13,"ankang-normal",0.04,1,false));
        this.ankangtalk = cc.sequence(newAnimationCreate(24,"ankang-talk",0.03,1,false));
    },
    retainActions:function(){
        this.ankangeat.retain();
        this.ankanglaugh.retain();
        this.ankangnormal.retain();
        this.ankangtalk.retain();
    },
    releaseActions:function(){
        this.ankangeat.release();
        this.ankanglaugh.release();
        this.ankangnormal.release();
        this.ankangtalk.release();
    }
});
