var CircleRun = cc.Sprite.extend({
    ctor:function(path,speed,deltaX,sourPosX){
        this.sourPosX = sourPosX;
        this.curDeltaX = 0;
        this.speed = speed;
        this.openUpdate = false;
        this.deltaX = deltaX;
        this._super(path);
        this.scheduleUpdate();
    },
    update:function(dt){
//		cc.log("dt = " + dt);
        if(this.openUpdate){
//			cc.log("formal enter update");
            this.curDeltaX += this.speed * dt;
            this.setPositionX(this.getPositionX() - this.speed * dt);
            if(this.curDeltaX >= this.deltaX){
                this.curDeltaX = 0;
//				cc.log("回到原处");
                this.setPositionX(this.sourPosX);
            }
        }
    },
    run:function(){
        this.openUpdate = true;
        this.resume();
    },
    stop:function(){
        this.openUpdate = false;
        this.pause();
    }
});


var CircleRun2 = cc.Sprite.extend({
    ctor:function(path,speed,deltaX,sourPosX){
        this.idx = 0;
        this.sourPosX = sourPosX;
        this.curDeltaX = 0;
        this.speed = speed;
        this.openUpdate = false;
        this.deltaX = deltaX;
        this._super(path);
        this.scheduleUpdate();
    },
    update:function(dt){
//		cc.log("dt = " + dt);
        if(this.openUpdate){
//			cc.log("formal enter update");
            this.curDeltaX += this.speed * dt;
            this.setPositionX(this.getPositionX() - this.speed * dt);
            if(this.curDeltaX >= this.deltaX){
                this.idx ++;
                this.curDeltaX = 0;
//				cc.log("回到原处,idx%3 = "+this.idx%3);
                if(this.idx % 3 == 1)
                    this.setPositionX(this.sourPosX);
            }
        }
    },
    run:function(){
        this.openUpdate = true;
        this.resume();
    },
    stop:function(){
        this.openUpdate = false;
        this.pause();
    }
});


var CircleRun3 = cc.Sprite.extend({
    ctor:function(path,speed,deltaX,sourPosX,direction){
        this.sourPosX = sourPosX;
        this.curDeltaX = 0;
        this.direction = direction;
        this.speed = speed;
        this.deltaX = deltaX;
        this.openUpdate = false;
        this._super(path);
        this.scheduleUpdate();
    },
    update:function(dt){
//		cc.log("dt = " + dt);
        if(this.openUpdate){
//			cc.log("formal enter update");
            if(this.direction == 1){//1run to left and -1run to right
                this.curDeltaX += this.speed * dt;
                this.setPositionX(this.getPositionX() - this.speed * dt);
                if(this.getPositionX() <= (this.sourPosX - this.deltaX)){
                    this.curDeltaX = 0;
                    this.setPositionX(this.sourPosX);
                }
            }else if(this.direction == -1){
                this.curDeltaX += this.speed * dt;
                this.setPositionX(this.getPositionX() + this.speed * dt);
                if(this.getPositionX() >= (this.sourPosX + this.deltaX)){
                    this.curDeltaX = 0;
                    this.setPositionX(this.sourPosX);
                }
            }
        }
    },
    run:function(){
        this.openUpdate = true;
        this.resume();
    },
    stop:function(){
        this.openUpdate = false;
        this.pause();
    }
});
function newCircleRun(parent,path,speed,deltaX,sourPosX,posY,zorder,direction){
    if(1 == direction){
        var spr1 = new CircleRun3(path,speed,deltaX,sourPosX,direction);
        parent.addChild(spr1,zorder);
        spr1.setPosition(sourPosX,posY);

        var spr2 = new CircleRun3(path,speed,deltaX,sourPosX+deltaX,direction);
        parent.addChild(spr2,zorder);
        spr2.setPosition(sourPosX+deltaX,posY);
    }else{
        var spr1 = new CircleRun3(path,speed,deltaX,sourPosX,direction);
        parent.addChild(spr1,zorder);
        spr1.setPosition(sourPosX,posY);

        var spr2 = new CircleRun3(path,speed,deltaX,sourPosX+deltaX,direction);
        parent.addChild(spr2,zorder);
        spr2.setPosition(sourPosX+deltaX,posY);
    }

    spr1.setGlobalZOrder(-3);
    spr2.setGlobalZOrder(-3);

    spr1.run();
    spr2.run();

    return [spr1,spr2];
}
function newCircleRun1(parent,path,speed,deltaX,sourPosX,posY,zorder,direction){
    if(1 == direction){
        var spr1 = new CircleRun3(path,speed,deltaX,sourPosX,direction);
        parent.addChild(spr1,zorder);
        spr1.setPosition(sourPosX,posY);

        var spr2 = new CircleRun3(path,speed,deltaX,sourPosX+deltaX,direction);
        parent.addChild(spr2,zorder);
        spr2.setPosition(sourPosX+deltaX,posY);
    }else{
        var spr1 = new CircleRun3(path,speed,deltaX,sourPosX,direction);
        parent.addChild(spr1,zorder);
        spr1.setPosition(sourPosX,posY);

        var spr2 = new CircleRun3(path,speed,deltaX,sourPosX+deltaX,direction);
        parent.addChild(spr2,zorder);
        spr2.setPosition(sourPosX+deltaX,posY);
    }

    spr1.setGlobalZOrder(-1);
    spr2.setGlobalZOrder(-1);

    spr1.run();
    spr2.run();

    return [spr1,spr2];
}