var EmitterQiqiu = cc.Node.extend({
    delataTime:null,
    firstPlay:null,
    gameidx:null,
    timeinterval:null,
    emitScale:null,
    ctor:function(parent,emitspeed,emitinterval){
        this._super();
        this.initData(parent,emitspeed,emitinterval);


    },
    initData:function(parent,emitspeed,emitinterval){
        this._parent = parent;
        this._emitspeed = emitspeed;
        this._emitinterval = emitinterval;
        this.delataTime = 0;
        this.timeinterval = 0;
        this.gameidx = 1;
        this.emitScale = 1;
        this.firstPlay = true;
    },
    setEmitSpeed:function(emitspeed){
        this._emitspeed = emitspeed;
    },
    setEmitInterval:function(emitinterval){
        this._emitinterval = emitinterval;
    },
    getEmitIntervl:function(){
        return this._emitinterval;
    },
    startEmit:function(){
        this.scheduleUpdate();
        this.schedule(function(){
            if(this.getPositionY() > 450){
                this.setPositionY(getRand1ToN(200));
            }
            if(this.getPositionY() < 100){
                this.setPositionY(getRand1ToN(100)+100);
            }

            var spr = QiQiuSprite.reCreateRand(this._emitspeed);
            spr.setScale(this.emitScale);
            this._parent.addChild(spr,1000);
            spr.setPosition(this.getPosition());
            switch (this.gameidx){
                case 1:
                    this.setPos1();
                    break;
                case 2:
                    this.setPos2();
                    break;
                case 3:
                    this.setPos3();
                    break;
                case 4:
                    this.setPos4();
                    break;
                case 5:
                    this.setPos5();
                    break;
                case 6:
                    this.setPos6();
                    break;
                default:
                    this.setPos7();
                    break;
            }
            this._emitinterval = 100;
        }.bind(this),this.getEmitIntervl(),cc.REPEAT_FOREVER,0);
    },
    changeToAnotherKind:function(){
        // this.unscheduleAllCallbacks();
        this.delataTime = getRand1ToN(3) + 1;
        this.setPositionX(1200);
        this.gameidx = getRand1ToN(6);
        var arr = [true, false];
        var id = 1;
        if(Math.random() < 0.5){
            id = 1;
        }else{
            id = -1;
        }
        cc.log("切换到另一种玩法,玩法id是 " + this.gameidx);
        this.emitScale = 1 + Math.random()*0.2*id;
        switch (this.gameidx){
            case 1:
                this.setPos1();
                break;
            case 2:
                this.setPos2();
                break;
            case 3:
                this.setPos3();
                break;
            case 4:
                this.setPos4();
                break;
            case 5:
                this.setPos5();
                break;
            case 6:
                this.setPos6();
                break;
            default:
                this.setPos7();
                break;
        }
    },
    setPos1:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(this.getPositionY()+30);
    },
    setPos2:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(this.getPositionY()-30);
    },
    setPos3:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(getRand0ToN(300)+200);
    },
    setPos4:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(this.getPositionY()-20);
    },
    setPos5:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(this.getPositionY()+20);
    },
    setPos6:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(this.getPositionY());
    },
    setPos7:function(){
        this.setEmitSpeed(1.4);
        this.setEmitInterval(0.1);
        this.setPositionY(240);
    },
    update:function(dt){
        if(this.firstPlay){
            this.firstPlay = false;
            this.changeToAnotherKind();
        }
        this.delataTime += dt;
        this.timeinterval += dt;
        if(this.delataTime > 3){
            //换另一种玩法
            this.delataTime = 0;
            this.changeToAnotherKind();
        }
    },
});