// function getRand1ToN(n){
// 	return Math.ceil(Math.random()*n);
// }
var SPRITE_WIDTH = 32;                                               
var SPRITE_HEIGHT = 32;                                               
var DEBUG_NODE_SHOW = true;

function randTo(center,delta){//return center-delta to center+delta 获得的是小数
	var del = Math.random() * delta;
	var rand1 = center - del;
	var rand2 = center + del;
	return Math.random() * (rand2 - rand1) + rand1;
}
var GiftEmitter = cc.Node.extend({
	couldEmit:null,
	emitPos:null,
	ctor:function(space,emitPos,type){//type从1开始
		this._super();

		this.emitPos = emitPos;
		this.couldEmit = false;
		this.type = type;
		this.kinds = [
			{
				//null not use
			},
			{
				range:190,
				speed:520,
				rotatespeed:1,
				deltatime:0.2,
			},{
				range:230,
				speed:580,
				rotatespeed:0.6,
				deltatime:0.17,
			},{
				range:250,
				speed:620,
				rotatespeed:0.4,
				deltatime:0.14,
			},{
				range:270,
				speed:660,
				rotatespeed:0.3,
				deltatime:0.11,
			},{
				range:290,
				speed:700,
				rotatespeed:0.2,
				deltatime:0.08,
			}
		];

		this.startEmit();
	},
	createRandBody:function(){
		var body = new cp.Body(1,cp.momentForBox(1, randTo(SPRITE_WIDTH, 5), randTo(SPRITE_HEIGHT, 5)));
		GlobalJingyuLayer.space.addBody(body);

		body.setVel(cc.p(randTo(0, this.kinds[this.type].range),this.kinds[this.type].speed));//设置向上的瞬时速度
//		body.applyImpulse(cp.v(0,300),cp.v(0,0));//提供一个瞬时的冲量300I
//		body.applyForce(cp.v(0,300),cp.v(0,0));//提供一个持续的力300N

		var shape = new cp.BoxShape(body,SPRITE_WIDTH,SPRITE_HEIGHT);
		shape.setElasticity(randTo(0.5, 0.2));
		shape.setFriction(randTo(0.5, 0.2));
		GlobalJingyuLayer.space.addShape(shape);

		shape.group = 10;
		shape.layers = 1;
		shape.setCollisionType(10002);

		var sprite = new cc.PhysicsSprite("res/jingyu/texture/gifts/jing-wanju-"+getRand1ToN(9)+".png");
		sprite.setScale(0.02);
		sprite.setBody(body);
		sprite.setPosition(this.emitPos);
		sprite.setGlobalZOrder(-2);
		GlobalJingyuLayer.addChild(sprite,65534);

		sprite.retain();//必须要retain,可是已经即将sprite加载到this上了啊。。
		body.datas = sprite;
		// body.datas.retain();

		sprite.runAction(cc.spawn(cc.scaleBy(1,30,30),cc.repeat(cc.rotateBy(randTo(this.kinds[this.type].rotatespeed,0.3),360),8)));
//		ddPlayEffect("effect","res/jingyu/audio/effect/pen.mp3",false);
        jsb.AudioEngine.play2d("res/jingyu/audio/effect/pen.mp3");
		// cc.log("createSprite B");
	},
	startEmit:function(){
		this.couldEmit = true;
		this.openSchedule();
	},
	emitSchedule:function(){
		// cc.log("schedule...");
		if(this.couldEmit){
			this.createRandBody();
		}
	},
	openSchedule:function(){
		this.schedule(this.emitSchedule, this.kinds[this.type].deltatime, cc.REPEAT_FOREVER, 0);
	},
	pauseEmitter:function(){
		this.couldEmit = false;
		this.unschedule(this.emitSchedule);
	},
	resumeEmitter:function(){
		this.couldEmit = true;
		this.openSchedule();
	},
	deleteEmitter:function(){
		this.couldEmit = false;
		this.unscheduleAllCallbacks();
	}
});
var GiftLayer = cc.Layer.extend({
	ctor:function(){
		this._super();
		// this.addColorBG();
		this.addEmitter();
	},
	addEmitter:function(){
		this.emitters = [];

		for(var i = 0;i <= 5;i ++){
			if(i == 0){
				this.emitters[0] = new GiftEmitter(GlobalJingyuLayer.space,cc.p(1136/2 - 60,330),1);//0 is not use
				this.emitters[0].pauseEmitter(1);
			}else{
				this.emitters[i] = new GiftEmitter(GlobalJingyuLayer.space,cc.p(1136/2 - 60,330),i);
				this.emitters[i].setGlobalZOrder(65535);
				this.addChild(this.emitters[i],65535);
				this.emitters[i].setPosition(cc.p(-70,220));
				this.emitters[i].pauseEmitter();
			}
		}
	},
	emitTimes:function(times){
		for(var i = 1;i <= times;i ++){
			this.createRandBody();
		}
	},
	startEmit:function(kind){
		for(var i = 1;i <= 5;i ++){
			if(i == kind){
				this.emitters[i].resumeEmitter();
			}else{
				this.emitters[i].pauseEmitter();
			}
		}
	},
	stopEmit:function(){
		for(var i = 1;i <= 5;i ++){
			this.emitters[i].pauseEmitter();
		}
	},
	addColorBG:function(){
		this.bg = new cc.LayerColor(new cc.Color(90, 90, 90, 255),1136,640);
		this.addChild(this.bg,65530);
	},
	// setupDebugNode : function(){
	// 	this._debugNode = new cc.PhysicsDebugNode(this.space );
	// 	this._debugNode.visible = false ;
	// 	this.addChild( this._debugNode );
	// },
});

var ChipmunkTestScene = cc.Scene.extend({
	ctor:function(){
		this._super();

		var layer = new GiftLayer();
		this.addChild(layer);
		
		return true;
	}
});