function createShakeNode(path,parent,position,zorder,durtime,gridsize,shaketimes,amplitude){
//    var shakeNode = new cc.NodeGrid();
//
//    var sprite = new cc.Sprite(path);
//    sprite.setPosition(0,0);
//    shakeNode.addChild(sprite);
//
//    shakeNode.runAction(
//        cc.repeatForever(cc.waves3D(durtime, gridsize, shaketimes,amplitude))
//    );
//
//    parent.addChild(shakeNode,zorder);
//    shakeNode.setPosition(position);
//    shakeNode.releaseSelf = function(){
//        this.removeFromParent(true);
//    }
//    return shakeNode;
    var sprite = new cc.Sprite(path);
    sprite.setPosition(0,0);
    parent.addChild(sprite,zorder);
    sprite.setPosition(position);
}

function createStaticNode(path,parent,position,zorder){//不翻转
    var sprite = new cc.Sprite(path);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    sprite.releaseSelf = function(){
        this.removeFromParent(true);
    }
    return sprite;
}
function createStaticNode_Reverse(path,parent,position,zorder){//翻转
    var sprite = new cc.Sprite(path);
    sprite.flippedX = true;
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    sprite.releaseSelf = function(){
        this.removeFromParent(true);
    }
    return sprite;
}

function createSkeletonAnimation(json,atlas,scale,parent,position,zorder,priority,defaultanimation,iscircle){
    // this.zhangyu = sp.SkeletonAnimation.createWithJsonFile('res/zhangyu/zhangyu.json', 'res/zhangyu/zhangyu.atlas', 0.6);
    // this.zhangyu.setPosition(cc.p(GW2 - 150, GH2 - 20));
    // this.zhangyu.setAnimation(0, 'zhangyutumozhi', true);//animation happy normal talk
    // //spineBoy.setAnimationListener(this, this.animationStateEvent);
    // this.addChild(this.zhangyu, 4);
    var skeletonanimation = sp.SkeletonAnimation.createWithJsonFile(json,atlas,scale);
    skeletonanimation.setPosition(position);
    skeletonanimation.setAnimation(priority,defaultanimation,iscircle);
    parent.addChild(skeletonanimation,zorder);


    skeletonanimation.releaseSelf = function(){
        this.removeFromParent(true);
    }
    return skeletonanimation;
}

function newAnimationCreate(number,prefix,delayPerUnit,times,resumeOriginFrame) {
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    if (typeof(resumeOriginFrame) == "undefined")
        resumeOriginFrame = true;
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    var suffix = ".png";
    for (var i = 1; i <= number; i++) {
        var fileName = prefix + i + ".png";
        animation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(fileName));
    }
    var animate = cc.animate(animation);
    if (-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return action;
}
function newAnimationCreate_idx(idx,number,prefix,delayPerUnit,times,resumeOriginFrame) {
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if (typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = true;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	var suffix = ".png";
	for (var i = idx; i <= number; i++) {
		var fileName = prefix + i + ".png";
		animation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(fileName));
	}
	var animate = cc.animate(animation);
	if (-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);

	return action;
}

//传统的通过单个文件的方式加载
function animationCreate(number,prefix,start,delayPerUnit,times,resumeOriginFrame){
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    if(typeof(resumeOriginFrame) == "undefined")
        resumeOriginFrame = true;
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    (0 == start) ? number : number += 1;
    for(var i = start;i <= number - 1;i ++ ){
        var fileName = prefix + i + ".png";
        animation.addSpriteFrameWithFile(fileName);
    }
    var animate = cc.animate(animation);
    if(-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return action;
}



function addTrash(parent,position){
    var size = cc.winSize;
    var particleSystem = new cc.ParticleSystem("res/ditu/texture/trash.plist");
    particleSystem.setAutoRemoveOnFinish(true);
    particleSystem.setPosition(position);
    particleSystem.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
    parent.addChild(particleSystem, 1000);
    particleSystem.duration = getRand1ToN(5);
}



function addWateBobble(parent,position){
    var size = cc.winSize;
    var particleSystem1 = new cc.ParticleSystem("res/ditu/texture/waterbobble.plist");
    particleSystem1.setAutoRemoveOnFinish(true);
    particleSystem1.setPosition(position);
    particleSystem1.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
    parent.addChild(particleSystem1, 1000);
    particleSystem1.duration = getRand1ToN(5);
}




function registerTouchEventOneByOne(target, isSwallow, priority) {
    var obj = {
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: isSwallow == null ? true : isSwallow,
        onTouchBegan: target.onTouchBegan.bind(target)
    };

    if (target.onTouchMoved) {
        obj.onTouchMoved = target.onTouchMoved.bind(target)
    }

    if (target.onTouchEnded) {
        obj.onTouchEnded = target.onTouchEnded.bind(target)
    }

    if (target.onTouchCanceled) {
        obj.onTouchCanceled = target.onTouchCanceled.bind(target)
    }
    var eventListener = cc.EventListener.create(obj);
    cc.eventManager.addListener(eventListener, priority || target);
    return eventListener;
}


function sendCustomEvent(eventname) {
    var event = new cc.EventCustom(eventname);
    cc.eventManager.dispatchEvent(event);
}

function recvCustomEvent(eventname,callback){
    cc.eventManager.addCustomListener(eventname,callback);
}

function sendCustomEventAddUserData(eventname,userdata) {
    var event = new cc.EventCustom(eventname);
    event.setUserData(userdata);
    cc.eventManager.dispatchEvent(event);
}

function unRegistCustomEvent(eventname){
	cc.eventManager.removeCustomListeners(eventname);
}

var MenuSingleSprite = cc.Sprite.extend({
    enable:null,
    ctor:function(frame_name){
        this._super(frame_name);
        this.enable = true;
    },
    setEnable:function(enable){
        this.enable = enable;
    },
    isEnable:function(){
        return this.enable;
    }
});

var MenuSingleSprite1 = cc.Sprite.extend({
    enable:null,
    name:null,
    ctor:function(frame_name){
        this._super(cc.spriteFrameCache.getSpriteFrame(frame_name + ".png"));
//		this.setTexture(cc.spriteFrameCache.getSpriteFrame(frame_name + ".png"));
        this.name = frame_name;
        this.enable = true;
    },
    setEnable:function(enable){
        this.enable = enable;
    },
    isEnable:function(){
        return this.enable;
    },
    frameName:function(){
        return this.name;
    }
});

var HeadSprite = cc.Sprite.extend({
    name_dragon:null,
    ctor:function(dragon_name){
        this._super();
        if (dragon_name) {
            this.setTexture(headPath(dragon_name));
            this.name_dragon = dragon_name;
        }
    },
    setDragon:function(dragon_name){
        this.name_dragon = dragon_name;
        this.setTexture(headPath(dragon_name));
    },
    getDragon:function(){
        return this.name_dragon;
    }
});

var ToolSprite = cc.Sprite.extend({
    name_tool:null,
    dragon_name:null,
    ctor:function(dragon_name, tool_name){
        this._super();
        if (dragon_name && tool_name) {
            this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(toolPath(dragon_name, tool_name)));
            this.dragon_name = dragon_name;
            this.name_tool = tool_name;
        }
    },
    setTool:function(dragon_name, tool_name){
        this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(toolPath(dragon_name, tool_name)));
        this.name_tool = tool_name;
        this.dragon_name = dragon_name;
    },
    toolName:function(){
        return this.name_tool;
    }
});

var AnimalSprite = cc.Sprite.extend({
    name_animal:null,
    enable:null,
    ctor:function(animal_name, step){
        this._super();
        if (animal_name) {
            this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(animalPath(animal_name, step, 1)));
            this.name_animal = animal_name;
        }

        this.enable = true;
    },
    setDragon:function(animal_name, step){
        this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(animalPath(animal_name, step, 1)));
        this.name_animal = animal_name;
    },
    dragonName:function(){
        return this.name_animal;
    },
    setEnable:function(enable){
        this.enable = enable;
    },
    isEnable:function(){
        return this.enable;
    }
});

function mylog(content){
    cc.log("duoduo :"+ content);
}

function textureOrPlistPath(name, index,ext) {//ankang,1,plist/pvr.ccz
    return "res/"+name+"/texture/"+name+"-"+index+"."+ext;
}


function backKeyListenerAdd(parent){
                var self = parent;
                cc.eventManager.addListener({
                    event: cc.EventListener.KEYBOARD,
                    onKeyReleased: function(keyCode, event) {
                        if (keyCode == cc.KEY.back) {
                            self.releaseRes();
                            cc.director.popScene();
                        }
                        else if (keyCode == cc.KEY.menu) {

                        }
                    }}, self);
}

function popSceneMenu(parent){
    var arry_ret_menu = [];

    var menu_item_1 = new cc.MenuItemImage(
        "res/home/RetBtnNormal.png",
        "res/home/RetBtnHigh.png",
        function () {
//            if (AD_ENABLE && ARRY_AD_LIST && ARRY_AD_LIST.length) {
//                GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_LIST.length;
//            }
            parent.releaseRes();
            cc.director.popScene();
            //cc.director.runScene(new DadituScene());
        }, parent);
    menu_item_1.attr({
        x: 70,
        y: cc.winSize.height - 70,
        anchorX: 0.5,
        anchorY: 0.5
    });
    arry_ret_menu[0] = menu_item_1;

    var menu_ret = new cc.Menu(arry_ret_menu);
    menu_ret.x = 0;
    menu_ret.y = 0;
    parent.addChild(menu_ret,65535);


    backKeyListenerAdd(parent);
}

function popSceneMenu1(parent){
    var arry_ret_menu = [];

    var menu_item_1 = new cc.MenuItemImage(
        "res/home/RetBtnNormal.png",
        "res/home/RetBtnHigh.png",
        function () {
            parent.releaseRes();
            // cc.director.popScene();
            cc.director.runScene(new HomeScene());
        }, parent);
    menu_item_1.attr({
        x: 70,
        y: cc.winSize.height - 70,
        anchorX: 0.5,
        anchorY: 0.5
    });
    arry_ret_menu[0] = menu_item_1;

    var menu_ret = new cc.Menu(arry_ret_menu);
    menu_ret.x = 0;
    menu_ret.y = 0;
    parent.addChild(menu_ret,65535);
}
