function backPath(name) {
    return "res/" + name + "/background.png";
}

function compPath(animal, comp){
    return "res/" + animal + "/" + comp + ".png";
}

function headPath(dragon_name) {
    return "res/home/head/head_" + dragon_name + ".png";
}

function menuBack(){
    return "res/play/icon_back.png";
}

function menuPath(menu_name){
    return "res/home/" + menu_name + ".png";
}

function namePath(dragon_name) {
    return "res/home/name/name_" + dragon_name + ".png";
}

function selectPath(vip_status, dragon_name) {
    if (vip_status) {
        return "res/home/lock/lock_" + dragon_name + ".png";
    } else {
        return "res/home/select/select_" + dragon_name + ".png";
    }
}

function animalPath(animal_name, step, frame) {
    return animal_name + "-" + step + "yachi" + frame + ".png";
}

function toolPath(dragon_name, tool_name) {
    return dragon_name + "_tools_" + tool_name + ".png";
}

function aniFrame(dragon_name, type, index) {
    return dragon_name + "_" + type + "_" + index + ".png";
}

function oldAniFrame(dragon_name, type, index) {
    return "res/play/" + dragon_name + "/" + type + "/" + index + ".png";
}

function decoratePath(dragon_name, decorate_name) {
    return "res/play/" + dragon_name + "/" + decorate_name + ".png";
}
function baikePath(dragon_name) {
    return "res/home/desc/desc_" + dragon_name + ".png";
}
function getDragonScene(dragon_name) {
    Config_Play.schedule_count = 0;
    console.log(dragon_name);
    switch (dragon_name) {
        case "bawang":
        {
            return new BaWangScene();
            break;
        }
        case "egg":
        {
            return new EggScene();
            break;
        }
        case "ji":
        {
            return new JiScene();
            break;
        }
        case "jia":
        {
            return new JiaScene();
            break;
        }
        case "snake":
        {
            return new SnakeScene();
            break;
        }
        case "wan":
        {
            return new WanScene();
            break;
        }
        case "yi":
        {
            return new YiScene();
            break;
        }
        case "sword":
        {
            return new SwordScene();
            break;
        }
        case "triangle":
        {
            return new TriangleScene();
            break;
        }
        default:
            break;
    }
}

function setFrame(sprite, frame_name) {
    sprite.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(frame_name));
}

function runDragonScene(dragon_name) {
    cc.director.runScene(getDragonScene(dragon_name));
}

function pushDragonScene(dragon_name) {
    cc.director.pushScene(getDragonScene(dragon_name));
}

function soundPath(dragon_name, type, action) {
    switch (type) {
        case "baike":
        {
            return "res/sound/baike/" + dragon_name + ".mp3";
            break;
        }
        case "play":
        {
            return "res/sound/play/" + dragon_name + "/" + action + ".mp3";
            break;
        }
        case "tips":
        {
            return "res/sound/play/tips/" + action + ".mp3";
            break;
        }
        case "name":
        {
            return "res/sound/name/" + dragon_name + ".mp3";
            break;
        }
        case "home":
        {
            return "res/sound/home/" + action + ".mp3";
            return
        }
        case "click":
            return "res/sound/click.mp3";
            break;
        case "feature":
            return "res/sound/feature/" + dragon_name + ".mp3";
        default:
            break;
    }
}

function tipsSound(type, action) {
    return "res/sound/normal/" + type + "-" + action + ".mp3";
}
