var Card = cc.Sprite.extend({
	dragonName:null,
	open:null,
	sprite_cover:null,
	sprite_dragon:null,
	ctor:function(dragonName,sceneIndex){//bawang,1/2/3
		this.init(dragonName,sceneIndex);
		this._super(this.frontPath);			

		this.sprite_dragon = new cc.Sprite(this.dragonPath);
		this.sprite_dragon.x = 213 / 2.0;
		this.sprite_dragon.y = 230 / 2.0;
		this.addChild(this.sprite_dragon);

		this.sprite_cover = new cc.Sprite(this.backPath);
		this.sprite_cover.x = 213 / 2.0;
		this.sprite_cover.y = 230 / 2.0;
		this.addChild(this.sprite_cover);
	},
	init:function(dragonName,sceneIndex){
		this.open = false;
		this.sceneIndex  = sceneIndex;
		this.dragonName  = dragonName;
		this.dragonPath  = "res/kapai/common/"+dragonName+".png";
		this.backPath	 = "res/kapai/scene"+sceneIndex+"/card_back.png";
		this.frontPath	 = "res/kapai/scene"+sceneIndex+"/card.png";
	},	
	dragonName:function(){
		return this.dragonName;
	},
	shake:function(cb){
		var interval = 0.08;
		var angle = 10;
		this.runAction(cc.sequence(
				cc.spawn(
						cc.callFunc(function(){
							ddPlayEffect("effect", "res/kapai/common/fail.mp3", false);
						}),
						createRotateAction1(2,0.05,9)
				),
				cc.delayTime(0.1),
				cc.callFunc(function() {
					if (cb) {
						cb();
					}
				})));
	},
	isOpen:function(){
		return this.open;
	},
	setOpen:function(is_open){
		this.open = is_open;
	},
	turnOver:function(open, cb){
		if (open) {
			this.sprite_cover.runAction(cc.sequence(cc.scaleTo(0.05, 0, 1), cc.delayTime(0.1), cc.callFunc(function() {
				if (cb) {
					cb();
				}
			})));
		} else {
			this.sprite_cover.runAction(cc.sequence(cc.scaleTo(0.05, 1, 1), cc.delayTime(0.1), cc.callFunc(function() {
				if (cb) {
					cb();
				}
			})));
		}
	}
});
